# Mapping cpanel pcakge to eenos package
def package_map():
    p_map={
        'MAXADDON':'addondomains',
        'BWLIMIT':'bandwidth',
        'IP':'dedicatedip',
        'MAXPOP':'email',
        'FEATURELIST':'feature',
        'MAXFTP':'ftp',
        'MAXLST':'maillist',
        'MAX_EMAILACCT_QUOTA':'mailquota',
        'MAXPARK':'parkeddomains',
        'QUOTA':'quota',
        'HASSHELL':'shell',
        'MAXSQL':'sql',
        'MAXSUB':'subdomains',        
        'lve_io': 'io',
        'lve_iops':'iops',
        'lve_ep':'maxEntryProcs',
        'lve_pmem':'mem',
        'lve_nproc':'nproc',
        'lve_cpu':'speed',
        'lve_mem':'vmem'
    }
    return p_map

def default_package(name=None):
    package={
        'addondomains': 'unlimited',
        'bandwidth': 'unlimited',
        'dedicatedip': 'no',
        'email': 'unlimited',
        'feature': 'Default',
        'ftp': 'unlimited',
        'maillist': 'unlimited',
        'mailquota': 'unlimited',    
        'owner': 'root',
        'parkeddomains': 'unlimited',
        'quota': 'unlimited',
        'shell': 'no',
        'sql': 'unlimited',
        'subdomains': 'unlimited',
    }
    if name:
        package['name']=name
    return package

def user_config(name=None):
    data={
        'addondomains': 'unlimited',
        'bandwidth': 'unlimited',
        'contactemail': 'sample@eenos.com',        
        'dkim': 'on',
        'domain': 'localhost.com',
        'email': 'unlimited',
        'feature': 'Default',
        'ftp': 'unlimited',
        'homedir': '/home/nouser',
        'language': 'en',
        'maillist': 'unlimited',
        'mailquota': 'unlimited',
        'mailserver': 'local',
        'nameservers': ['ns1.localhost.com', 'ns2.localhost.com'],
        'owner': 'root',
        'package': 'Default',
        'parkeddomains': 'unlimited',
        'quota': 'unlimited',
        'reseller': {'selfown': 'off', 'status': 'off'},
        'setuptime': '0000-00-00 00:00:00',
        'shell': {'shell': '/sbin/nologin', 'status': 'off'},
        'spf': 'on',
        'sql': 'unlimited',
        'subdomains': 'unlimited',
        'theme': 'default',
        'user': 'nouser',
        }
    if name:
        data['user']=name
        data['homedir']='/home/'+name
    return data

def user_map():
    data={
        'MAXADDON':'addondomains',
        'BWLIMIT':'bandwidth',
        'CONTACTEMAIL':'contactemail',
        'HASDKIM':'dkim',
        'DNS':'domain',
        'MAXPOP':'email',
        'FEATURELIST':'feature',
        'MAXFTP':'ftp',
        'LOCALE':'language',
        'MAXLST':'maillist',
        'MAX_EMAILACCT_QUOTA':'mailquota',
        'OWNER':'owner',
        'PLAN':'package',
        'MAXPARK':'parkeddomains',
        'DISK_BLOCK_LIMIT':'quota',
        'HASSPF':'spf',
        'MAXSQL':'sql',
        'MAXSUB':'subdomains',
        'STARTDATE':'setuptime',
        'USER':'user',    
        'lve_io': 'io',
        'lve_iops':'iops',
        'lve_ep':'maxEntryProcs',
        'lve_pmem':'mem',
        'lve_nproc':'nproc',
        'lve_cpu':'speed',
        'lve_mem':'vmem',        
    }
    return data

def default_reseller_conf(reseller=None):
    data={
        'accounts': [],
        'contactemail': 'sample@eenos.com',
        'ips': {'ipv4': '127.0.0.1',
                'ipv6': ''},
        'name': 'none',
        'nameservers': ['ns1.localhost.com', 'ns2.localhost.com'],        
        'reseller_bandwidth': 'unlimited',
        'reseller_limt': 'unlimited',
        'reseller_quota': 'unlimited',
        }
    if reseller:
        data['name']=reseller
    return data

def domain_conf(domain=None,serveradmin=None,user=None,docroot=None,ipv4=None,ipv6=None,alias=list()):
    data={
        'app': 'default',
        'docroot': '',
        'group': '',
        'ips': {'ipv4': '',
                'ipv6': ''},
        'nodejs': 'default',
        'modsecurity': 'off',
        'nodejsselector': 'off',
        'php': 'default',
        'phpfpm': 'off',
        'phpselecter': 'off',
        'pyselector': 'off',
        'python': 'default',
        'redirect': {'http-to-https': 'off', 'www-to-nonwww': 'none'},
        'ruby': 'default',
        'rubyselector': 'off',
        'serveradmin': '',
        'serveralias': [],
        'servername': '',
        'siteredirect': {'status': 'off', 'url': ''},
        'type': 'website',
        'usecanonicalname': 'Off',
        'user': '',
        'userdir': 'off',
        }
    if domain:
        data['servername']=domain
        data['serveradmin']='web-master@'+domain
    if serveradmin:
        data['serveradmin']=serveradmin
    if user:
        data['user']=user
        data['group']=user
    if docroot:
        data['docroot']=docroot
    if ipv4:
        data['ips']['ipv4']=ipv4
    if ipv6:
        data['ips']['ipv6']=ipv6
    if bool(alias):
        data['serveralias']=alias
    return data

def dns_conf(domain=None,ipv4=None,ipv6=None,NS=list(),MX=dict()):
    data={
        'A': {},
        'AAAA': {},
        'CNAME': {},
        'MX': {'0': 'example.com'},
        'NS': ['ns1.example.com', 'ns2.example.com'],
        'TXT': {},
        'dkim': {'status': 'on'},
        'ips': {'ipv4': '127.0.0.1',
                'ipv6': '2a01:04f8:0120:2093:0000:0000:0000:0017'},
        'spf': {'ipv4': ['188.40.192.204'],
                'ipv6': ['2a01:04f8:0120:2093:0000:0000:0000:0017'],
                'status': 'on'},
        'sub': {},
        'zone': 'example.com',
        'zonetempalte': 'default',
        }
    if domain:
        data['zone']=domain
        data['MX']['0']=domain
    if ipv4:
        data['ips']['ipv4']=ipv4
        data['spf']['ipv4']=list()
        data['spf']['ipv4'].append(ipv4)
    if ipv6:
        data['ips']['ipv6']=ipv6
        data['spf']['ipv6']=list()
        data['spf']['ipv6'].append(ipv6)
    if bool(NS):
        data['NS']=NS
    if bool(MX):
        data['MX']=MX
    return data

def mysql_user_create(mysql_user=None,password=None,host=None):
    querry='''CREATE USER IF NOT EXISTS '_DEMO_USER_'@'localhost' IDENTIFIED WITH mysql_native_password AS '_DEMO_PASS_';'''
    if mysql_user:
        querry=querry.replace('_DEMO_USER_',mysql_user)
    if password:
        querry=querry.replace('_DEMO_PASS_',password)
    if host:
        querry=querry.replace('localhost',host)
    return querry
def mysql_user_grant_usage(mysql_user=None,host=None):
    querry='''GRANT USAGE ON *.* TO `_DEMO_USER_`@`localhost`;'''
    if mysql_user:
        querry=querry.replace('_DEMO_USER_',mysql_user)
    if host:
        querry=querry.replace('localhost',host)
    return querry

def mysql_user_grant_all(mysql_user=None,db=None,host=None):
    querry='''GRANT ALL PRIVILEGES ON `_DEMO_DB_`.* TO `_DEMO_USER_`@`localhost`;'''
    if db:
        querry=querry.replace('_DEMO_DB_',db)
    if mysql_user:
        querry=querry.replace('_DEMO_USER_',mysql_user)
    if host:
        querry=querry.replace('localhost',host)
    return querry