import os
from pprint import pprint
from cptoeenos import fullconvert,userconvert,bkpconvert,pkgconvert,validators

def start(choice,log,logfile):
    log("Starting Backup conversion")
    log("Log file : %s" %logfile)    
    if bool(choice['workdir']) and os.path.isdir(choice['workdir']):        
        if bool(choice['saveto']) and os.path.isdir(choice['saveto']):
            try:
                myworkdir=str(choice['workdir'])+'/cptoeenos.workdir'
                if not os.path.isdir(myworkdir):
                    log("Creating work dir : %s" %myworkdir)
                    os.makedirs(myworkdir)
                choice['myworkdir']=myworkdir
            except Exception as e:
                log("Unable to create my workdir : %s" %myworkdir)
                log(str(e))               
                 
            if bool(choice['full']):
                if validators.is_cpanel_server():
                    fullconvert.convert(choice,log)
                else:
                    log("This is not a Cpanel/WHM Server. Please use this tool in a Cpanel server")
            if bool(choice['user']):
                if validators.is_cpanel_server():
                    userconvert.convert(choice,log)
                else:
                    log("This is not a Cpanel/WHM Server. Please use this tool in a Cpanel server")

            if bool(choice['packages']):
                if validators.is_cpanel_server():
                    pkgconvert.convert(choice,log)
                else:
                    log("This is not a Cpanel/WHM Server. Please use this tool in a Cpanel server")
            if bool(choice['backupfile']):
                bkpconvert.convert(choice,log)
            if bool(choice['postupload']) :
                if os.path.isfile(choice['postupload']):
                    try:
                        log("Executing post upload script : %s" %choice['postupload'])
                        upath=str(choice['saveto'])
                        cmd=str(choice['postupload'])+' '+upath
                        log("Command Send : %s" %cmd)
                        os.system(cmd)
                    except Exception as e:
                        log(str(e))
                        pass
                else:
                    log("The post upload script not fond.")              
        else:
            log("Upload directory not found : %s" %choice['saveto'])
            log("Backup conversion failed")        
    else:
        log("Working Directory not found : %s" %choice['workdir'])
        log("Backup conversion failed")
    