import os
import shutil
from pprint import pprint
import glob
import re
from cptoeenos import tools,conf

def convert_cp(pfile,log,plan_name,owner=None):
    cplan={}
    pdata=tools.readplain(pfile,log)
    if bool(pdata):
        # print(pfile)
        # pprint(pdata)
        cl=False
        if any("lve_" in s for s in pdata):
            cl=True        
        else:
            cl=False
        # if cl:
        for item in pdata:
            if cl:
                if str(item).endswith("=DEFAULT"):
                    new_item=str(item).replace("=DEFAULT","=default")                    
                    pdata[pdata.index(item)]=new_item
            if str(item).endswith("=y"):
                new_item=str(item).replace("=y","=yes")                  
                pdata[pdata.index(item)]=new_item
            if str(item).endswith("=n"):
                new_item=str(item).replace("=n","=no")                
                pdata[pdata.index(item)]=new_item
        if bool(pdata):
            # pprint(pdata)
            cplan=conf.default_package(plan_name)
            # Set the same plan name
            cplan['name']=plan_name
            try:
                if owner:
                    cplan['owner']=owner
                else:
                    if str(plan_name).__contains__('_'):
                        psn=plan_name.split('_')[0]
                        if os.path.isfile('/var/cpanel/users/'+psn):
                            cplan['owner']=psn
                        else:
                            cplan['owner']='root'                    
                    else:
                        cplan['owner']='root'
            except Exception as e:
                log(str(e))
                # Set the default plan owner as root             
                cplan['owner']='root'
                pass
            if cl:
                cplan['cloudlinux']={}
                cplan['cloudlinux']['status']='on'
            plan_maps=conf.package_map()
            for item in pdata:
                feature=item.split("=")
                # print(feature)
                try:
                    if str(feature[0]).startswith('lve_'):
                       cplan['cloudlinux'][plan_maps[feature[0]]]= feature[1]
                    else:
                        cplan[plan_maps[feature[0]]]=feature[1]
                except Exception:
                    # print(str(e))
                    pass
                # The cpanel featues and eenos features are  different.
                cplan['feature']='Default'
        else:
            cplan=conf.default_package(plan_name)
    else:
        cplan=conf.default_package(plan_name)    
    # pprint(cplan)    
    return cplan

# convert space and dot in plan names
def convert_name(name,log):
    name=re.sub(r"[\s.]+", '_', name)    
    return name

def get_cp_packages(log):
    packages={}
    if os.path.isdir('/var/cpanel/packages'):
        pfiles=glob.glob('/var/cpanel/packages/*')  
        pfiles.sort()
        if bool(pfiles):
            for pfile in pfiles:
                if os.path.isfile(pfile): 
                    pname=pfile.split('/')[-1]                              
                    if bool(re.search(r"[\s.]+",pname)):                        
                        plan_name=tools.convert_package_feature_name(pname,log)
                        log("Changing Cpanel Package Name from [ %s ] to [ %s ]" %(pname,plan_name))
                    else:
                        plan_name=pname
                    log("Converting cpanel Package : %s" %plan_name)
                    packages[plan_name]=convert_cp(pfile,log,plan_name)
    if bool(packages):                                    
        return(packages)
    else:
        return dict()


def convert(choice,log):
    log("------------------------")
    log("WHM Packages conversion")
    log("------------------------")
    # pprint(choice)
    basedir=choice['myworkdir']
    workdir=basedir+'/EenosHostingPackages'
    uploadpath=str(choice['saveto'])+'/EenosHostingPackages'
    result=None
    try:
        if os.path.isdir(uploadpath):
            log("Cleaning upload path : %s" %uploadpath)
            shutil.rmtree(uploadpath)
        if os.path.isdir(workdir):
            log("Cleaning work dir : %s" %workdir)
            shutil.rmtree(workdir)
        if not os.path.isdir(workdir):
            log("re-creating work dir : %s" %workdir)
            os.makedirs(workdir)
    except Exception as e:
        log(str(e))
        pass

    log("Collecting  WHM packages ..")
    cp_pksgs=get_cp_packages(log)
    if bool(cp_pksgs):
        for package in cp_pksgs:
            pfile= workdir+'/'+package+'.yaml'
            log("Creating Eenos package file  [ %s ] => [ %s]" %(package,pfile))
            try:
                tools.writeyaml(pfile,cp_pksgs[package],log)
            except Exception as e:
                log(str(e))
                pass
        # pprint(choice)
        
        log("Copying  Eenos package files to Upload Folder : %s" %uploadpath)
        try:
            shutil.copytree(workdir,uploadpath)
            log("Cleanigng work directory")
            shutil.rmtree(workdir) 
            log("Please Upload all the  Package files from %s to your Eenos Server Pacakge folder /var/eenos/packages/" %uploadpath) 
            log("The cpanel to Eenos  package conversion completed")         
            log("Eenos Hosting Packages : %s" %uploadpath)
            result= uploadpath       
        except Exception as e:
            log(str(e))
            pass
    else:
        log("Unable to generate Eenos packages !!!")
    return result

