import tarfile
import os

''' uncompressed tar file (.tar) '''
def make_tar_from_dir(output_filename,source_dir,log):
    result=None
    if os.path.isdir(source_dir):
        try:
            log("Creating archive file %s from %s . Please wait ..." %(output_filename,source_dir))
            with tarfile.open(output_filename, "w:") as tar:
                tar.add(source_dir, arcname=os.path.basename(source_dir))
            result=output_filename
        except Exception as e:
            log(str(e))
            result=None
            pass
    else:
        log("Source dir not found, unable to create archive file %s" %output_filename)
        result=None
    return result

# Gziped tar file tar.gz

def make_gzip_tar_from_dir(output_filename,source_dir,log):
    result=None
    if os.path.isdir(source_dir):
        try:
            log("Creating gzipped archive file ../%s from ../%s . Please wait ..." %(str(output_filename).split("/")[-1],str(source_dir).split("/")[-1]))
            with tarfile.open(output_filename, "w:gz") as tar:
                tar.add(source_dir, arcname=os.path.basename(source_dir))
            result=output_filename
        except Exception as e:
            log(str(e))
            result=None
            pass
    else:
        log("Source dir not found, unable to create gzip archive file %s" %output_filename)
        result=None
    return result


def untar_to_dir(source,target,log):
    result=None    
    if os.path.isfile(source) and tarfile.is_tarfile(source):
        try:
            with tarfile.open(source,'r') as tar:
                tar.extractall(path=target)
            result=target
        except Exception as e:
            log(str(e))
            result=None
            pass
    else:
        log("Un Supported archive format")
    return result

def make_gzip_single_file(source_file,target_file,log):
    result=None
    if os.path.isfile(source_file):
        try:
            with tarfile.open(target_file, "w:gz") as tar:
                tar.add(source_file, os.path.basename(source_file))
            if os.path.isfile(target_file):
                result=target_file
        except Exception as e:
            log(str(e))
            result=None
            pass
    return result