# Copyright (c) eenos.com . All rights reserved
import os,sys
import yaml
import re
from pprint import pprint
from hashlib import blake2b,md5,sha1
import uuid

def getid():   
    h = blake2b(digest_size=10)
    stra=str(uuid.uuid4())
    h.update(bytes(stra,'utf-8'))
    tid=h.hexdigest()
    return(tid)

def readyaml(datafile,log): 
    if os.path.isfile(datafile):  
        with open(datafile, 'r') as stream:
            try:
                data_loaded = yaml.load(stream, Loader=yaml.FullLoader)
            except ValueError as e:
                log(str(e))
                data_loaded={}
                pass
    else:
        log("Datafile not found : "+datafile)
        data_loaded={}  
    if bool(data_loaded): 
        return data_loaded
    else:
        return dict()   
    
def readyamlnolog(datafile): 
    if os.path.isfile(datafile):  
        with open(datafile, 'r') as stream:
            try:
                data_loaded = yaml.load(stream, Loader=yaml.FullLoader)                
            except ValueError as e:
                print(str(e))
                data_loaded=dict()
                pass
    else:
        data_loaded={} 
    if bool(data_loaded): 
        return data_loaded
    else:
        return dict()
    
def yaml2dict(datafile):
    data=readyamlnolog(datafile)
    pprint(data)
    # yaml.dump(data, sys.stdout)
    
def writeyaml(datafile,data,log):   
    status=False
    with open(datafile, 'w', encoding='utf8') as outfile:
        try:
            yaml.dump(data,outfile,sort_keys=True,default_flow_style=False)            
            status=True
        except ValueError as e:
            log(str(e))
            status=False
    return status
    
def writeyamlnolog(datafile,data):   
    status=False
    with open(datafile, 'w', encoding='utf8') as outfile:
        try:
            yaml.dump(data,outfile,sort_keys=True,default_flow_style=False)            
            status=True
        except ValueError as e:
            print(str(e))
            status=False
    return status

def readplain(dfile,log):
    if os.path.isfile(dfile):
        data=list()
        try:
            pre=[]
            with open(dfile,'r') as f:
                lines=f.readlines()
            for l in lines:
                d=l.strip()
                pre.append(d)
            data=list(dict.fromkeys(pre))
        except Exception as e :
            log(str(e))
            data=[]
            pass
    else:
        data=list()    
    return data    

def readplainnolog(dfile):
    if os.path.isfile(dfile):
        data=list()
        try:
            pre=[]
            with open(dfile,'r') as f:
                lines=f.readlines()
            for l in lines:
                d=l.strip()
                pre.append(d)
            data=list(dict.fromkeys(pre))
        except Exception as e :            
            data=[]
            pass
    else:
        data=list()    
    return data    
# wite a list to plain file avoid duplicate 
def writeplain(dfile,datas,log):
    status=False
    data=list(dict.fromkeys(datas))
    try:
        with open(dfile, 'w') as f:
            f.write('\n'.join(data))            
        status=True
    except Exception as e:
        log(str(e))
        status=False
    return status


def convert_package_feature_name(name,log):
    name=re.sub(r"[\s.]+", '-', name)    
    return name

def get_reseller(rfile,log):
    rdata={}
    if os.path.isfile(rfile) and os.stat(rfile).st_size >0:
        pdatas=readplain(rfile,log)
        if bool(pdatas):
            try:
                for ruser in pdatas:
                    rta=ruser.split(':')
                    rdata[rta[0]]=rta[1].split(',')
            except Exception as e:
                log(str(e))
                pass
    return rdata

def get_hash(filename,log,result=False):
    BUF_SIZE = 65536
    _md5=md5()
    _sha1=sha1()
    try:
        with open(filename, 'rb') as f:
            while True:
                data = f.read(BUF_SIZE)
                if not data:
                    break
                _md5.update(data)
                _sha1.update(data)
        if result:
            sums={}
            sums['md5']=str(_md5.hexdigest())
            sums['sha1']=str(_sha1.hexdigest())
            return sums
        else:
            log("md5sum is : %s" %_md5.hexdigest())
            log("sha1sum is : %s" %_sha1.hexdigest())
    except Exception as e:
        log(str(e))
        pass

def get_pkgacct_cmd(choice):
    cmd='/usr/local/cpanel/bin/pkgacct --incremental'
    if bool(choice['skipmysql']):
        cmd+=' --skipmysql'
    if bool(choice['skippgsql']):
        cmd+=' --skippgsql'
    if bool(choice['skiphomedir']):
        cmd+=' --skiphomedir'
    if bool(choice['skipemail']):
        cmd+=' --skipmailconfig'
    if bool(choice['skipresellerconfig']):
        cmd+=' --skipresellerconfig'
    return cmd
    
