import os
import sys
import logging
import pwd
from logging.handlers import TimedRotatingFileHandler,BaseRotatingHandler,RotatingFileHandler
from pathlib import Path

formatter = logging.Formatter('[%(asctime)s +%(msecs)04d] [cptoeenos] - %(name)s - %(message)s',datefmt='%Y-%m-%d %H:%M:%S')
cformatter = logging.Formatter('[%(asctime)s +%(msecs)04d] [cptoeenos] - %(message)s',datefmt='%Y-%m-%d %H:%M:%S')
uformatter = logging.Formatter('[%(asctime)s +%(msecs)04d] [cptoeenos] - %(message)s',datefmt='%Y-%m-%d %H:%M:%S')
def get_console_handler():
    console_handler = logging.StreamHandler(sys.stdout)
    console_handler.setFormatter(cformatter)
    return console_handler

def get_file_handler(logfile,logdir):      
    logpath=logdir+'/'+logfile
    file_handler =logging.FileHandler(logpath)
    file_handler.setFormatter(formatter)
    return file_handler

def get_logger(logfile):
    uid=os.geteuid()
    if uid ==0:
        logdir='/var/log'
    else:
        logdir=str(Path.home())
    logpath=logdir+'/'+logfile
    logger= logging.getLogger()
    logger.setLevel(logging.INFO)
    if sys.stdin.isatty():
        logger.addHandler(get_console_handler())
    logger.addHandler(get_file_handler(logfile,logdir))
    logger.propagate = False
    return logger,logpath

def get_daemon_logger(logfile):        
    uid=os.geteuid()
    if uid ==0:
        logdir='/var/log'
    else:
        logdir=str(Path.home())
    logpath=logdir+'/'+logfile    
    logger= logging.getLogger()
    logger.setLevel(logging.INFO)
    logger.addHandler(get_file_handler(logfile,logdir))
    logger.propagate = False
    return logger,logpath