"""Copyright (c) eenos.com. All rights reserved, https://eenos.com/epl """
import os
import pwd

def isroot():
    if os.geteuid()==0:
        return True
    else:
        return False

# Safely chown files and soft links
def safe_chown(path,user,group):
    uid=pwd.getpwnam(user).pw_uid
    gid=pwd.getpwnam(group).pw_gid
    if os.path.islink(path):
        try:
            os.lchown(link,uid,gid)
        except Exception as e:
            print((str(e)))
            pass    
    elif os.path.isfile(path):
        try:
            os.chown(path,uid,gid)
        except Exception as e:
            print((str(e)))
            pass
    elif os.path.isdir(path):
        try:
            os.chown(path,uid,gid)
        except Exception as e:
            print((str(e)))
            pass
    else:
        pass
# Recursively chown dir and all files     
def safe_chown_r(path,user,group):
    uid=pwd.getpwnam(user).pw_uid
    gid=pwd.getpwnam(group).pw_gid   
    if os.path.isdir(path):
        for parentdir, subdirlist, fileList in os.walk(path,followlinks=False):
            if  parentdir != path:
                dlit=str.split(parentdir,path+'/')[-1]
                ddir=os.path.join(path,dlit)
            else:
                ddir=path
            try:
                os.chown(ddir,uid,gid)
            except Exception as e:
                print((str(e)))
                pass
            for fname in fileList:
                sfile=os.path.join(parentdir,fname)               
                if os.path.islink(sfile):
                    try:
                        os.lchown(sfile,uid,gid)
                    except Exception as e:
                        print((str(e)))
                        pass
                elif os.path.isfile(sfile):
                    try:
                        os.chown(sfile,uid,gid)
                    except Exception as e:
                        print((str(e)))
                        pass
                else:
                    continue
# Safe link chown
def safe_link_chown(link,user,group):
    uid=pwd.getpwnam(user).pw_uid
    gid=pwd.getpwnam(group).pw_gid
    if os.path.islink(link):
        try:
            os.lchown(link,uid,gid)
        except Exception as e:
            print((str(e)))
            pass
'''
mode=0o644
'''
def safe_chmod(path,mode=0o644):    
    if os.path.islink(path):
        return False
    elif os.path.isfile(path) or os.path.isdir(path):
        try:
            os.chmod(path,mode)
            return True
        except Exception as e:
            print(str(e))
            pass
    else:
        return False

# Recursively chmod dir and all files     
def safe_chmod_r(path,filemode=0o644,dirmod=0o755):    
    if os.path.isdir(path):
        for parentdir, subdirlist, fileList in os.walk(path,followlinks=False):
            if  parentdir != path:
                dlit=str.split(parentdir,path+'/')[-1]
                ddir=os.path.join(path,dlit)
            else:
                ddir=path
            try:
                os.chmod(ddir,dirmod)
            except Exception as e:
                print((str(e)))
                pass
            for fname in fileList:
                sfile=os.path.join(parentdir,fname)                               
                if os.path.isfile(sfile):
                    try:
                        os.chmod(sfile,filemode)
                    except Exception as e:
                        print((str(e)))
                        pass
                else:
                    continue

def safe_rsync(user,log=None):
    uid=pwd.getpwnam(user).pw_uid
    gid=pwd.getpwnam(user).pw_gid
    os.setgid(gid)
    os.setuid(uid)
    if log:
        log('*****Switching as user for rsync  uid, gid = %d, %d' % (os.getuid(), os.getgid()))
    return
