import os
import shutil
from pprint import pprint
import glob
import re
from cptoeenos import tools,commands,cpanel,tarops

def convert(choice,log):    
    cpuser=choice['user']
    log("--------------------------------------")
    log(" User Account conversion : %s" %cpuser)
    log("--------------------------------------")
    basedir=choice['myworkdir']
    workdir=basedir+'/cpmove-'+cpuser    
    result=None
    try:
        if os.path.isdir(workdir):
            log("Cleaning work directory : %s" %workdir)
            shutil.rmtree(workdir)
    except Exception as e:
        log(str(e))
        pass
    cp_cmd=tools.get_pkgacct_cmd(choice)
    cmd=cp_cmd+' '+cpuser+' '+basedir    
    try:
        log(cmd)
        commands.live(cmd,log)
        cresult=workdir
    except Exception as e:
        log(str(e))
        cresult=False
        pass
    if cresult and os.path.isdir(cresult) and os.path.isfile(cresult+'/cp/'+cpuser):
        log("Cpanel backup generated successfully  : %s" %cresult)
        log("Proceeding with backup conversion")
        backup=cpanel.start(cpuser,cresult,choice,log)
        if backup:
            outputfile=backup+'.tar.gz'
            archfile=tarops.make_gzip_tar_from_dir(outputfile,backup,log)
            if archfile:
                pkgname=str(archfile).split('/')[-1]
                log("Cpanel account converted successfully  : %s " %pkgname)
                uploadpath=str(choice['saveto'])+'/'+pkgname
                try:
                    log("Uploading Eenos backup to : %s" %uploadpath)
                    shutil.copy(archfile,uploadpath)
                    result=uploadpath
                except Exception as e:
                    log(str(e))
                    result=None
                    pass
                try:
                    log("Cleaning temporary backup files .. %s" %backup)                    
                    shutil.rmtree(backup)
                    os.remove(archfile)
                except Exception as e:
                    log(str(e))
                    pass
                if result:
                    log("===================================")
                    log("Your Eenos Backup is : %s" %result)
                    tools.get_hash(result,log)
                else:
                    log("Cpanel to Eenos conversion failed.")                    
            else:
                log("Unable to create archive backup file , backup failed")
                result=None
        else:
            log("Cpanel to Eenos account conversion failed !!!") 
    else:
        log("Cpanel backup generation failed. Unable to converet backup to eenos ")    
    return result
    # pprint(choice)